import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_SendSSHPublicKeyCommand, se_SendSSHPublicKeyCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class SendSSHPublicKeyCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSEC2InstanceConnectService", "SendSSHPublicKey", {})
    .n("EC2InstanceConnectClient", "SendSSHPublicKeyCommand")
    .f(void 0, void 0)
    .ser(se_SendSSHPublicKeyCommand)
    .de(de_SendSSHPublicKeyCommand)
    .build() {
}
