/**
 * <p>This is the <i> Amazon EC2 Instance Connect API Reference</i>. It
 *             provides descriptions, syntax, and usage examples for each of the actions for Amazon EC2
 *             Instance Connect. Amazon EC2 Instance Connect enables system administrators to publish
 *             one-time use SSH public keys to EC2, providing users a simple and secure way to connect
 *             to their instances.</p>
 *         <p>To view the Amazon EC2 Instance Connect content in the <i> Amazon EC2 User
 *                 Guide</i>, see <a href="https://docs.aws.amazon.com/AWSEC2/latest/UserGuide/Connect-using-EC2-Instance-Connect.html">Connect to
 *                 your Linux instance using EC2 Instance Connect</a>.</p>
 *         <p>For Amazon EC2 APIs, see the <a href="https://docs.aws.amazon.com/AWSEC2/latest/APIReference/Welcome.html">Amazon EC2 API
 *                 Reference</a>.</p>
 *
 * @packageDocumentation
 */
export * from "./EC2InstanceConnectClient";
export * from "./EC2InstanceConnect";
export { ClientInputEndpointParameters } from "./endpoint/EndpointParameters";
export type { RuntimeExtension } from "./runtimeExtensions";
export type { EC2InstanceConnectExtensionConfiguration } from "./extensionConfiguration";
export * from "./commands";
export * from "./models";
export { EC2InstanceConnectServiceException } from "./models/EC2InstanceConnectServiceException";
