import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { EC2InstanceConnectClientResolvedConfig } from "../EC2InstanceConnectClient";
export interface EC2InstanceConnectHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface EC2InstanceConnectHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    EC2InstanceConnectClientResolvedConfig,
    HandlerExecutionContext,
    EC2InstanceConnectHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultEC2InstanceConnectHttpAuthSchemeParametersProvider: (
  config: EC2InstanceConnectClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<EC2InstanceConnectHttpAuthSchemeParameters>;
export interface EC2InstanceConnectHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<EC2InstanceConnectHttpAuthSchemeParameters> {}
export declare const defaultEC2InstanceConnectHttpAuthSchemeProvider: EC2InstanceConnectHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: EC2InstanceConnectHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: EC2InstanceConnectHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
